silk/urls.py
from django.urls import path

from silk.views.clear_db import ClearDBView
from silk.views.cprofile import CProfileView
from silk.views.profile_detail import ProfilingDetailView
from silk.views.profile_dot import ProfileDotView
from silk.views.profile_download import ProfileDownloadView
from silk.views.profiling import ProfilingView
from silk.views.raw import Raw
from silk.views.request_detail import RequestView
from silk.views.requests import RequestsView
from silk.views.sql import SQLView
from silk.views.sql_detail import SQLDetailView
from silk.views.summary import SummaryView

app_name = 'silk'
urlpatterns = [
    path(route='', view=SummaryView.as_view(), name='summary'),
    path(route='requests/', view=RequestsView.as_view(), name='requests'),
    path(
        route='request/<uuid:request_id>/',
        view=RequestView.as_view(),
        name='request_detail',
    ),
    path(
        route='request/<uuid:request_id>/sql/',
        view=SQLView.as_view(),
        name='request_sql',
    ),
    path(
        route='request/<uuid:request_id>/sql/<int:sql_id>/',
        view=SQLDetailView.as_view(),
        name='request_sql_detail',
    ),
    path(
        route='request/<uuid:request_id>/raw/',
        view=Raw.as_view(),
        name='raw',
    ),
    path(
        route='request/<uuid:request_id>/pyprofile/',
        view=ProfileDownloadView.as_view(),
        name='request_profile_download',
    ),
    path(
        route='request/<uuid:request_id>/json/',
        view=ProfileDotView.as_view(),
        name='request_profile_dot',
    ),
    path(
        route='request/<uuid:request_id>/profiling/',
        view=ProfilingView.as_view(),
        name='request_profiling',
    ),
    path(
        route='request/<uuid:request_id>/profile/<int:profile_id>/',
        view=ProfilingDetailView.as_view(),
        name='request_profile_detail',
    ),
    path(
        route='request/<uuid:request_id>/profile/<int:profile_id>/sql/',
        view=SQLView.as_view(),
        name='request_and_profile_sql',
    ),
    path(
        route='request/<uuid:request_id>/profile/<int:profile_id>/sql/<int:sql_id>/',
        view=SQLDetailView.as_view(),
        name='request_and_profile_sql_detail',
    ),
    path(
        route='profile/<int:profile_id>/',
        view=ProfilingDetailView.as_view(),
        name='profile_detail',
    ),
    path(
        route='profile/<int:profile_id>/sql/',
        view=SQLView.as_view(),
        name='profile_sql',
    ),
    path(
        route='profile/<int:profile_id>/sql/<int:sql_id>/',
        view=SQLDetailView.as_view(),
        name='profile_sql_detail',
    ),
    path(route='profiling/', view=ProfilingView.as_view(), name='profiling'),
    path(route='cleardb/', view=ClearDBView.as_view(), name='cleardb'),
    path(
        route='request/<uuid:request_id>/cprofile/',
        view=CProfileView.as_view(),
        name='cprofile',
    ),
]

silk/views/clear_db.py
import os
import shutil

from django.db import transaction
from django.shortcuts import render
from django.utils.decorators import method_decorator
from django.views.generic import View

from silk.auth import login_possibly_required, permissions_possibly_required
from silk.config import SilkyConfig
from silk.models import Profile, Request, Response, SQLQuery
from silk.utils.data_deletion import delete_model


@method_decorator(transaction.non_atomic_requests, name="dispatch")
class ClearDBView(View):

    @method_decorator(login_possibly_required)
    @method_decorator(permissions_possibly_required)
    def get(self, request, *_, **kwargs):
        return render(request, 'silk/clear_db.html')

    @method_decorator(login_possibly_required)
    @method_decorator(permissions_possibly_required)
    def post(self, request, *_, **kwargs):
        context = {}
        if 'clear_all' in request.POST:
            delete_model(Profile)
            delete_model(SQLQuery)
            delete_model(Response)
            delete_model(Request)
            tables = ['Response', 'SQLQuery', 'Profile', 'Request']
            context['msg'] = 'Cleared data for following silk tables: {}'.format(', '.join(tables))

            if SilkyConfig().SILKY_DELETE_PROFILES:
                dir = SilkyConfig().SILKY_PYTHON_PROFILER_RESULT_PATH
                for files in os.listdir(dir):
                    path = os.path.join(dir, files)
                    try:
                        shutil.rmtree(path)
                    except OSError:
                        os.remove(path)
                context['msg'] += '\nDeleted all profiles from the directory.'

        return render(request, 'silk/clear_db.html', context=context)

silk/views/cprofile.py
from django.shortcuts import render
from django.utils.decorators import method_decorator
from django.views.generic import View

from silk.auth import login_possibly_required, permissions_possibly_required
from silk.models import Request


class CProfileView(View):

    @method_decorator(login_possibly_required)
    @method_decorator(permissions_possibly_required)
    def get(self, request, *_, **kwargs):
        request_id = kwargs['request_id']
        silk_request = Request.objects.get(pk=request_id)
        context = {
            'silk_request': silk_request,
            'request': request}

        return render(request, 'silk/cprofile.html', context)

silk/views/profile_detail.py
from django.shortcuts import render
from django.utils.decorators import method_decorator
from django.views.generic import View

from silk.auth import login_possibly_required, permissions_possibly_required
from silk.models import Profile
from silk.views.code import _code_context, _code_context_from_request


class ProfilingDetailView(View):

    @method_decorator(login_possibly_required)
    @method_decorator(permissions_possibly_required)
    def get(self, request, *_, **kwargs):
        profile_id = kwargs['profile_id']
        context = {
            'request': request
        }
        profile = Profile.objects.get(pk=profile_id)
        file_path = profile.file_path
        line_num = profile.line_num

        context['pos'] = pos = int(request.GET.get('pos', 0))
        if pos:
            context.update(_code_context_from_request(request, prefix='pyprofile_'))

        context['profile'] = profile
        context['line_num'] = file_path
        context['file_path'] = line_num
        context['file_column'] = 5

        if profile.request:
            context['silk_request'] = profile.request
        if file_path and line_num:
            try:
                context.update(_code_context(file_path, line_num, profile.end_line_num))
            except OSError as e:
                if e.errno == 2:
                    context['code_error'] = e.filename + ' does not exist.'
                else:
                    raise e

        return render(request, 'silk/profile_detail.html', context)

silk/views/profiling.py
from django.db.models import Count, Sum
from django.shortcuts import render
from django.template.context_processors import csrf
from django.utils.decorators import method_decorator
from django.views.generic import View

from silk.auth import login_possibly_required, permissions_possibly_required
from silk.models import Profile, Request
from silk.request_filters import BaseFilter, FiltersManager, filters_from_request


class ProfilingView(View):
    show = [5, 10, 25, 100, 250]
    default_show = 25
    order_by = ['Recent',
                'Name',
                'Function Name',
                'Num. Queries',
                'Time',
                'Time on queries']
    defualt_order_by = 'Recent'
    session_key_profile_filters = 'session_key_profile_filters'
    filters_manager = FiltersManager(session_key_profile_filters)

    def __init__(self, **kwargs):
        super().__init__(**kwargs)

    def _get_distinct_values(self, field, silk_request):
        if silk_request:
            query_set = Profile.objects.filter(request=silk_request)
        else:
            query_set = Profile.objects.all()
        function_names = [x[field] for x in query_set.values(field).distinct()]
        # Ensure top, default option is ''
        try:
            function_names.remove('')
        except ValueError:
            pass
        return [''] + function_names

    def _get_function_names(self, silk_request=None):
        return self._get_distinct_values('func_name', silk_request)

    def _get_names(self, silk_request=None):
        return self._get_distinct_values('name', silk_request)

    def _get_objects(self, show=None, order_by=None, name=None, func_name=None, silk_request=None, filters=None):
        if not filters:
            filters = []
        if not show:
            show = self.default_show
        manager = Profile.objects
        if silk_request:
            query_set = manager.filter(request=silk_request)
        else:
            query_set = manager.all()
        if not order_by:
            order_by = self.defualt_order_by
        if order_by == 'Recent':
            query_set = query_set.order_by('-start_time')
        elif order_by == 'Name':
            query_set = query_set.order_by('-name')
        elif order_by == 'Function Name':
            query_set = query_set.order_by('-func_name')
        elif order_by == 'Num. Queries':
            query_set = query_set.annotate(num_queries=Count('queries')).order_by('-num_queries')
        elif order_by == 'Time':
            query_set = query_set.order_by('-time_taken')
        elif order_by == 'Time on queries':
            query_set = query_set.annotate(db_time=Sum('queries__time_taken')).order_by('-db_time')
        elif order_by:
            raise RuntimeError('Unknown order_by: "%s"' % order_by)
        if func_name:
            query_set = query_set.filter(func_name=func_name)
        if name:
            query_set = query_set.filter(name=name)
        for f in filters:
            query_set = f.contribute_to_query_set(query_set)
            query_set = query_set.filter(f)
        return list(query_set[:show])

    def _create_context(self, request, *args, **kwargs):
        request_id = kwargs.get('request_id')
        if request_id:
            silk_request = Request.objects.get(pk=request_id)
        else:
            silk_request = None
        show = request.GET.get('show', self.default_show)
        order_by = request.GET.get('order_by', self.defualt_order_by)
        if show:
            show = int(show)
        func_name = request.GET.get('func_name', None)
        name = request.GET.get('name', None)
        filters = self.filters_manager.get(request)
        context = {
            'show': show,
            'order_by': order_by,
            'request': request,
            'func_name': func_name,
            'options_show': self.show,
            'options_order_by': self.order_by,
            'options_func_names': self._get_function_names(silk_request),
            'options_names': self._get_names(silk_request),
            'filters': filters
        }
        context.update(csrf(request))
        if silk_request:
            context['silk_request'] = silk_request
        if func_name:
            context['func_name'] = func_name
        if name:
            context['name'] = name
        objs = self._get_objects(show=show,
                                 order_by=order_by,
                                 func_name=func_name,
                                 silk_request=silk_request,
                                 name=name,
                                 filters=[BaseFilter.from_dict(x) for _, x in filters.items()])
        context['results'] = objs
        return context

    @method_decorator(login_possibly_required)
    @method_decorator(permissions_possibly_required)
    def get(self, request, *args, **kwargs):
        return render(request, 'silk/profiling.html', self._create_context(request, *args, **kwargs))

    @method_decorator(login_possibly_required)
    @method_decorator(permissions_possibly_required)
    def post(self, request):
        filters = filters_from_request(request)
        filters_as_dict = {ident: f.as_dict() for ident, f in filters.items()}
        self.filters_manager.save(request, filters_as_dict)
        return render(request, 'silk/profiling.html', self._create_context(request))

silk/views/raw.py
import logging

from django.http import HttpResponse
from django.shortcuts import render
from django.utils.decorators import method_decorator
from django.views.generic import View

from silk.auth import login_possibly_required, permissions_possibly_required
from silk.models import Request

Logger = logging.getLogger('silk.views.raw')


class Raw(View):

    @method_decorator(login_possibly_required)
    @method_decorator(permissions_possibly_required)
    def get(self, request, request_id):
        typ = request.GET.get('typ', None)
        subtyp = request.GET.get('subtyp', None)
        body = None
        if typ and subtyp:
            silk_request = Request.objects.get(pk=request_id)
            if typ == 'request':
                body = silk_request.raw_body if subtyp == 'raw' else silk_request.body
            elif typ == 'response':
                Logger.debug(silk_request.response.raw_body_decoded)
                body = silk_request.response.raw_body_decoded if subtyp == 'raw' else silk_request.response.body
            return render(request, 'silk/raw.html', {
                'body': body
            })
        else:
            return HttpResponse(content='Bad Request', status=400)

silk/views/sql.py
from django.shortcuts import render
from django.utils.decorators import method_decorator
from django.views.generic import View

from silk.auth import login_possibly_required, permissions_possibly_required
from silk.models import Profile, Request, SQLQuery
from silk.utils.pagination import _page

__author__ = 'mtford'


class SQLView(View):

    @method_decorator(login_possibly_required)
    @method_decorator(permissions_possibly_required)
    def get(self, request, *_, **kwargs):
        request_id = kwargs.get('request_id')
        profile_id = kwargs.get('profile_id')
        context = {
            'request': request,
        }
        if request_id:
            silk_request = Request.objects.get(id=request_id)
            query_set = SQLQuery.objects.filter(request=silk_request).order_by('-start_time')
            for q in query_set:
                q.start_time_relative = q.start_time - silk_request.start_time
            page = _page(request, query_set)
            context['silk_request'] = silk_request
        if profile_id:
            p = Profile.objects.get(id=profile_id)
            page = _page(request, p.queries.order_by('-start_time').all())
            context['profile'] = p
        if not (request_id or profile_id):
            raise KeyError('no profile_id or request_id')
        # noinspection PyUnboundLocalVariable
        context['items'] = page
        return render(request, 'silk/sql.html', context)

silk/views/sql_detail.py
import os
import re

from django.core.exceptions import PermissionDenied
from django.shortcuts import render
from django.utils.decorators import method_decorator
from django.utils.safestring import mark_safe
from django.views.generic import View

from silk.auth import login_possibly_required, permissions_possibly_required
from silk.models import Profile, Request, SQLQuery
from silk.views.code import _code


class SQLDetailView(View):
    def _urlify(self, str):
        files = []
        r = re.compile(r'"(?P<src>.*\.py)", line (?P<num>[0-9]+).*')
        m = r.search(str)
        n = 1
        while m:
            group = m.groupdict()
            src = group['src']
            files.append(src)
            num = group['num']
            start = m.start('src')
            end = m.end('src')
            rep = '<a name={name} href="?pos={pos}&file_path={src}&line_num={num}#{name}">{src}</a>'.format(
                pos=n,
                src=src,
                num=num,
                name='c%d' % n,
            )
            str = str[:start] + rep + str[end:]
            m = r.search(str)
            n += 1
        return str, files

    @method_decorator(login_possibly_required)
    @method_decorator(permissions_possibly_required)
    def get(self, request, *_, **kwargs):
        sql_id = kwargs.get('sql_id', None)
        request_id = kwargs.get('request_id', None)
        profile_id = kwargs.get('profile_id', None)
        sql_query = SQLQuery.objects.get(pk=sql_id)
        pos = int(request.GET.get('pos', 0))
        file_path = request.GET.get('file_path', '')
        line_num = int(request.GET.get('line_num', 0))
        tb = sql_query.traceback_ln_only
        analysis = sql_query.analysis
        str, files = self._urlify(tb)
        if file_path and file_path not in files:
            raise PermissionDenied
        tb = [mark_safe(x) for x in str.split('\n')]
        context = {
            'sql_query': sql_query,
            'traceback': tb,
            'pos': pos,
            'line_num': line_num,
            'file_path': file_path,
            'analysis': analysis,
            'virtualenv_path': os.environ.get('VIRTUAL_ENV') or '',
        }
        if request_id:
            context['silk_request'] = Request.objects.get(pk=request_id)
        if profile_id:
            context['profile'] = Profile.objects.get(pk=int(profile_id))
        if pos and file_path and line_num:
            actual_line, code = _code(file_path, line_num)
            context['code'] = code
            context['actual_line'] = actual_line
        return render(request, 'silk/sql_detail.html', context)

silk/templates/silk/clear_db.html
{% extends 'silk/base/root_base.html' %}
{% load silk_inclusion %}
{% load static %}
{% block pagetitle %}Silky - Clear DB{% endblock %}

{% block menu %}
    {% root_menu request %}
{% endblock %}

{% block style %}
    {{ block.super }}
    <link rel="stylesheet" href="{% static 'silk/css/pages/clear_db.css' %}"/>
{% endblock %}

{% block js %}
    {{ block.super }}
    <script src="{% static 'silk/js/pages/clear_db.js' %}"></script>
{% endblock %}
{% block data %}
    <div class="wrapper">
        <div class="inner">
            <h2>Silk Clear DB</h2>
            <form class="cleardb-form" action="." method="post">
                {% csrf_token %}
                <div class="cleardb-form-wrapper">
                    <label>
                        <input type="checkbox" name="clear_requests" disabled="disabled"/>
                        Requests
                    </label>
                    <label>
                        <input type="checkbox" name="clear_profiling" disabled="disabled"/>
                        Profiling
                    </label>
                    <label>
                        <input type="checkbox" name="clear_all"/>
                        All
                    </label>
                </div>
                <button class="btn">Clear</button>
            </form>
            <div class="msg">{{ msg|linebreaks }}</div>
        </div>
    </div>

{% endblock %}

{# Hide filter hamburger menu #}
{% block top %}{% endblock %}
{% block filter %}{% endblock %}

silk/templates/silk/cprofile.html
{% extends "silk/base/detail_base.html" %}
{% load silk_filters %}
{% load silk_nav %}
{% load silk_inclusion %}
{% load static %}

{% block pagetitle %}Silky - CProfile - {{ silk_request.path }}{% endblock %}

{% block js %}
    <script type="text/javascript" src="{% static 'silk/lib/viz-lite.js' %}"></script>
    <script type="text/javascript" src="{% static 'silk/lib/svg-pan-zoom.min.js' %}"></script>
    {{ block.super }}
{% endblock %}

{% block style %}
    {{ block.super }}
    <link rel="stylesheet" href="{% static 'silk/css/components/summary.css' %}">
    <link rel="stylesheet" href="{% static 'silk/css/pages/cprofile.css' %}">
{% endblock %}

{% block menu %}
    {% request_menu request silk_request %}
{% endblock %}


{% block data %}
    <div class="wrapper">
        <div id="query-div">
            {% if silk_request.pyprofile %}
            <div id="pyprofile-div">
                <div class="heading">
                    <div class="inner-heading">CProfile</div>
                </div>
                <div class="description">
                    The below is a dump from the cPython profiler.
                </div>
                {% if silk_request.prof_file %}
                Click <a href="{% url 'silk:request_profile_download' request_id=silk_request.pk %}">here</a> to download profile.
                {% endif %}
                <pre class="pyprofile">{{ silk_request.pyprofile }}</pre>
                {% endif %}
            </div>
        </div>
    </div>

{% endblock %}

silk/templates/silk/profile_detail.html
{% extends "silk/base/detail_base.html" %}
{% load silk_filters %}
{% load silk_nav %}
{% load silk_inclusion %}
{% load static %}

{% block pagetitle %}Silky - Profile Detail - {{ silk_request.path }}{% endblock %}

{% block js %}
    <script type="text/javascript" src="{% static 'silk/lib/viz-lite.js' %}"></script>
    <script type="text/javascript" src="{% static 'silk/lib/svg-pan-zoom.min.js' %}"></script>
    {{ block.super }}
{% endblock %}

{% block style %}
    {{ block.super }}
    <link rel="stylesheet" href="{% static 'silk/css/components/summary.css' %}">
    <link rel="stylesheet" href="{% static 'silk/css/pages/profile_detail.css' %}">
{% endblock %}

{% block menu %}
    {% profile_menu request profile silk_request %}
{% endblock %}

{% block data %}
    <div class="wrapper">
        <div id="query-div">
            <div id="query-info-div">
                {% profile_summary profile %}
            </div>
            <div class="heading">
                <div class="inner-heading">
                    {% if profile.file_path and profile.line_num %}
                        {{ profile.file_path }}:{{ profile.line_num }}{% if profile.end_line_num %}:{{ profile.end_line_num }}{% endif %}
                    {% else %}
                        Location
                    {% endif %}
                </div>
            </div>
            <div class="description">
                Below shows where in your code this profile was defined. If your profile was defined dynamically (i.e in your settings.py),
                then this will show the range of lines that are covered by the profiling.
            </div>
            {% if code %}
                <pre id="code"><code>{% code code actual_line %}</code></pre>
            {% elif code_error %}
                <div id="error-div">
                    {{ code_error }}
                </div>
            {% endif %}

            {% if silk_request.prof_file %}
            <div class="heading">
                <div class="inner-heading">Profile graph</div>
            </div>
            <div class="description">
                Below is a graph of the profile, with the nodes coloured by the time taken (red is more time). This should give a good indication of the slowest path through the profiled code.</div>

                <span>Prune nodes taking up less than </span>
                <input id='percent' type="text" value='5'
                       onkeypress='return event.charCode >= 48 && event.charCode <= 57 && $("#percent").val().length < 2'
                       oninput="createViz()"
                >

                </input>
                <span>% of the total time</span>

            </div>
            <div id="graph-div">
            </div>
            {% url 'silk:request_profile_dot' request_id=silk_request.pk as profile_dot_url %}
            {{ profile_dot_url|json_script:'profileDotURL' }}
            <script src="{% static 'silk/js/pages/profile_detail.js' %}"></script>
            {% endif %}

            {% if silk_request.pyprofile %}
            <div id="pyprofile-div">
                <div class="heading">
                    <div class="inner-heading">Python Profiler</div>
                </div>
                <div class="description">
                    The below is a dump from the cPython profiler.
                </div>
                {% if silk_request.prof_file %}
                Click <a href="{% url 'silk:request_profile_download' request_id=silk_request.pk %}">here</a> to download profile.
                {% endif %}
                <pre class="pyprofile">{{ silk_request.pyprofile }}</pre>
                {% endif %}
            </div>

        </div>
    </div>

{% endblock %}

silk/templates/silk/sql.html
{% extends 'silk/base/base.html' %}

{% load silk_nav %}
{% load silk_filters %}
{% load static %}
{% load silk_inclusion %}

{% block pagetitle %}Silky - SQL - {{ silk_request.path }}{% endblock %}

{% block js %}
  <script type="text/javascript" src="{% static 'silk/lib/sortable.js' %}"></script>
  {{ block.super }}
{% endblock %}

{% block style %}
    <link rel="stylesheet" href="{% static 'silk/css/pages/sql.css' %}">
    <link rel="stylesheet" href="{% static 'silk/css/components/colors.css' %}">
    <link rel="stylesheet" href="{% static 'silk/css/components/numeric.css' %}">
    <link rel="stylesheet" href="{% static 'silk/css/components/summary.css' %}">
    <link rel="stylesheet" href="{% static 'silk/css/components/cell.css' %}">
{% endblock %}

{% block menu %}
    {% if profile %}
        {% profile_menu request profile silk_request %}
    {% elif silk_request %}
        {% request_menu request silk_request %}
    {% endif %}
{% endblock %}


{% block data %}
    {{ block.super }}
    <div class="wrapper">
        {% if profile or silk_request %}
            <div id="query-div">
            <div id="query-info-div">
        {% endif %}
        {% if profile %}
            {% profile_summary profile %}
        {% endif %}
        {% if silk_request %}
            {% request_summary silk_request %}
        {% endif %}
        {% if profile or silk_request %}
            </div>
            </div>
        {% endif %}
        <div id="table-div">

            <table class="sortable">
                <tr>
                    <th class="left-aligned">At</th>
                    <th class="left-aligned">Action</th>
                    <th class="left-aligned">Tables</th>
                    <th class="right-aligned">Num. Joins</th>
                    <th class="right-aligned">Execution Time (ms)</th>
                </tr>
                {% for sql_query in items %}
                    <!-- TODO: Pretty grimy... -->
                    <tr class="data-row" onclick="window.location=' \
                       {% if profile and silk_request %}\
                           {% url "silk:request_and_profile_sql_detail" silk_request.id profile.id sql_query.id %}\
                       {% elif profile %}\
                           {% url "silk:profile_sql_detail" profile.id sql_query.id %}\
                       {% elif silk_request %}\
                           {% url "silk:request_sql_detail" silk_request.id sql_query.id %}\
                       {% endif %}\
                        ';">
                        <td class="left-aligned">+{{ sql_query.start_time_relative }}</td>
                        <td class="left-aligned">{{ sql_query.first_keywords }}</td>
                        <td class="left-aligned">{{ sql_query.tables_involved|join:", " }}</td>
                        <td class="right-aligned">{{ sql_query.num_joins }}</td>
                        <td class="right-aligned">{{ sql_query.time_taken | floatformat:6 }}</td>
                    </tr>
                {% endfor %}

            </table>

            <div id="table-pagination" class="pagination">
                <div class="current">
                    Page {{ items.number }} of {{ items.paginator.num_pages }}.
                </div>

                <div class="step-links">
                    {% if items.has_previous %}
                        <a href="?page={{ items.previous_page_number }}">previous</a>
                    {% else %}
                        previous
                    {% endif %}
                    |
                    {% if items.has_next %}
                        <a href="?page={{ items.next_page_number }}">next</a>
                    {% else %}
                        next
                    {% endif %}
                </div>
            </div>
        </div>
    </div>





{% endblock %}

silk/templates/silk/sql_detail.html
{% extends "silk/base/detail_base.html" %}
{% load static %}
{% load silk_filters %}
{% load silk_nav %}
{% load silk_inclusion %}

{% block pagetitle %}Silky - SQL Detail - {{ silk_request.path }}{% endblock %}

{% block js %}
    {{ block.super }}
    <script src="{% static 'silk/js/pages/sql_detail.js' %}"></script>
{% endblock %}

{% block style %}
    {{ block.super }}
    <link rel="stylesheet" href="{% static 'silk/css/pages/sql_detail.css' %}"/>
{% endblock %}

{% block menu %}

    <a href="
        {% if silk_request and profile %}
            {% url "silk:request_and_profile_sql" silk_request.id profile.id %}
        {% elif silk_request %}
            {% url "silk:request_sql" silk_request.pk %}
        {% elif profile %}
            {% url "silk:profile_sql" profile.pk %}
        {% endif %}
    ">
        <div class="menu-item selectable-menu-item">
            <div class="menu-item-outer">
                <div class="menu-item-inner">&larr;</div>
            </div>
        </div>
    </a>

    <div class="menu-item menu-item-selected">
        <div class="menu-item-outer ">
            <div class="menu-item-inner">SQL Query</div>
        </div>
    </div>
{% endblock %}

{% block data %}
    <div class="wrapper">
        <div id="query-div">
            <pre id="query"><code>{{ sql_query.formatted_query|spacify|linebreaksbr }}</code></pre>
            <div id="query-info-div">
                <div id="time-taken-div">
                    <span class="numeric">{{ sql_query.time_taken }}<span class="unit">ms</span></span>
                </div>
                <div id="num-joins-div">
                    <span class="numeric">{{ sql_query.num_joins }}</span> joins
                </div>
            </div>

        </div>
        {% if analysis %}
        <div id="query-plan-div">
            <div class="heading">
                <div class="inner-heading">
                    Query Plan
                </div>
            </div>
            <code id="plan">{{ analysis | spacify | linebreaksbr }}</code>
        </div>
        {% endif %}
        <div id="traceback">
            <div class="heading">
                <div class="inner-heading">
                    Traceback
                </div>
            </div>
            <div class="description">
                The below is the Python stacktrace that leads up the execution of the above SQL query.
                Use it to figure out where and why this SQL query is being executed and whether or not
                it's actually neccessary.
            </div>
            {% for ln in traceback %}
                {% if ln %}
                    <div class="file-path {% if virtualenv_path not in ln %}not-{% else %}is-{% endif %}third-party">
                        {{ ln }}
                    </div>
                    {% if forloop.counter == pos %}
                        {% code code actual_line %}
                    {% endif %}
                {% endif %}
            {% endfor %}
        </div>
    </div>


{% endblock %}